// virtfor.cpp                                     
// virtual function and ploymorphic manager
                         
#include <iostream.h>

class Base                        // base class
   {
   public:
      virtual void show()         // virtual function
	 { cout << "\nBase"; }
   };
class Derv1 : public Base         // derived class 1
   {
   public:
      void show()
	 { cout << "\nDerv1"; }
   };
class Derv2 : public Base         // derived class 2
   {
   public:
      void show()
	 { cout << "\nDerv2"; }
   };

class Derv3 : public Base         // derived class 3
   {
   public:
      void show()
	 { cout << "\nDerv3"; }
   };

class Derv4 : public Base         // derived class 4
   {
   public:
      void show()
	 { cout << "\nDerv4"; }
   };

void main()
   {
   Derv1 dv1;           // object of derived class 1
   Derv2 dv2;           // object of derived class 2
   Derv3 dv3;           // object of derived class 3
   Derv4 dv4;           // object of derived class 4
   Base* ptr[4];        // pointer to the aaray of base class

   ptr[0] = &dv1;          // put address of dv1 in pointer[0]
   ptr[1] = &dv2;          // put address of dv2 in pointer[1]
   ptr[2] = &dv3;          // put address of dv3 in pointer[2]
   ptr[3] = &dv4;          // put address of dv4 in pointer[3]

   for (int i = 0; i <4; i++)
    ptr[i]->show();            // execute show()

   }

/*The following are the output of this program:
Derv1
Derv2
Derv3
*/